% "simulation2_pour_MCnaif" simule l'année pour notre assureur et retourne
% simplement s'il y a eu ruine ou non.
function ruine = simulation2_pour_MCnaif

kappa = 1.2;
z0 = 10000;
tau = 1.;
a = 70000;
R0 = 1000000;
T = 52;

% On initialise "ruine" à la valeur false.
ruine = false;

t = 0;
R = R0;
% Cette fois-ci il n'y a plus les listes des t et de R à maintenir, puisque
% nous ne voulons rien plotter. Noter que cela conduit à une économie de
% temps appréciable pour Matlab.
while true
    attente = -log(rand) / tau;
    if (t + attente < T)
        t = t + attente;
        R = R + attente * a;
        sinistre = Pareto (z0, kappa);
        R = R - sinistre;
        % Si R est négatif, il y a ruine, et on peut arrêter tout de suite
        % la simulation.
        if R < 0
            ruine = true;
            return
        end
    else
        % Pour la dernière étape où on atteint la fin de l'année il n'y a
        % plus rien à faire dans cette version, si ce n'est sortir de la
        % boucle !
        break;
    end
end

% La fonction renvoie la valeur de "ruine" (qui, si on atteint cette ligne,
% sera en l'occurrence forcément "false") et s'arrête.
return

end
