% Si on demande à "simulation2_pour_MCstrat" de retourner deux valeurs, la
% seconde valeur correspondra à la strate dans laquelle on se trouve.
function [ruine, strate] = simulation2_pour_MCstrat

kappa = 1.2;
z0 = 10000;
tau = 1.;
a = 70000;
R0 = 1000000;
T = 52;

ruine = false;
% On "strate" à 1. On fera monter "strate" quand on rencontrera des gros
% sinistres éventuels.
strate = 1;

t = 0;
R = R0;
while true
    attente = -log(rand) / tau;
    if (t + attente < T)
        t = t + attente;
        R = R + attente * a;
        sinistre = Pareto (z0, kappa);
        % On met à jour la strate.
        if sinistre > 800000
            strate = 3;
        elseif sinistre > 400000
            % Attention à ne pas tomber dans le piège de faire descendre
            % "strate" à la valeur 2 si un sinistre catastrophique a déjà
            % eu lieu ! D'où le « max ».
            strate = max (strate, 2);
        end
        R = R - sinistre;
        % Par rapport au programme précédent, nous ne terminons pas dès
        % qu'il y a ruine, car nous avons besoin de poursuivre la
        % simulation jusqu'au bout pour que les probabilités des
        % différentes strates soient calculables.
        if R < 0
            ruine = true;
        end
    else
        break;
    end
end

% La fonction renvoie les valeurs calculées pour "ruine" et "strate" et
% s'arrête.
return;

end
